INCLUDE(QtLibraries)

MACRO(RELOCATE_OSX_LIBRARY FROM_LIBRARY TO_LIBRARY IN_FILE)
	INSTALL(CODE
		"EXECUTE_PROCESS(
			COMMAND install_name_tool
				-change ${FROM_LIBRARY} ${TO_LIBRARY}
				\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${IN_FILE}
		)"
	)
ENDMACRO(RELOCATE_OSX_LIBRARY FROM_LIBRARY TO_LIBRARY IN_FILE)

MACRO(RENAME_OSX_LIBRARY NAME FILE)
	INSTALL(CODE
		"EXECUTE_PROCESS(
			COMMAND install_name_tool
				-id ${NAME}
				\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${FILE}
		)"
	)
ENDMACRO(RENAME_OSX_LIBRARY NAME FILE)

MACRO(INSTALL_OSX_LIBRARY LIBRARY)
	GET_FILENAME_COMPONENT(LIBRARY_PATH ${LIBRARY} PATH)
	GET_FILENAME_COMPONENT(LIBRARY_NAME ${LIBRARY} NAME)
	GET_FILENAME_COMPONENT(LIBRARY_NOEXT ${LIBRARY} NAME_WE)
	FILE(GLOB LIBRARY_FILES ${LIBRARY_PATH}/${LIBRARY_NOEXT}.*.dylib)
	INSTALL(FILES ${LIBRARY} ${LIBRARY_FILES} DESTINATION MacOS/)
	RENAME_OSX_LIBRARY("@executable_path/${LIBRARY_NAME}" MacOS/${LIBRARY_NAME})
ENDMACRO()

MACRO(RELOCATE_QT_LIBRARIES TARGET)
	FOREACH(QT_LIBRARY ${QT_ACTIVE_LIBRARIES} ${PHONON_LIBRARY})
		GET_FILENAME_COMPONENT(QT_FRAMEWORK_DIR ${QT_LIBRARY} NAME) # Eg QtCore.framework
		GET_FILENAME_COMPONENT(QT_FRAMEWORK_NAME ${QT_LIBRARY} NAME_WE) # Eg QtCore
		RELOCATE_OSX_LIBRARY(
			${QT_FRAMEWORK_DIR}/Versions/4/${QT_FRAMEWORK_NAME}
			@executable_path/../Frameworks/${QT_FRAMEWORK_DIR}/Versions/4/${QT_FRAMEWORK_NAME}
			${TARGET}
		)
	ENDFOREACH(QT_LIBRARY ${QT_ACTIVE_LIBRARIES})
ENDMACRO(RELOCATE_QT_LIBRARIES TARGET)

MACRO(INSTALL_QT_FRAMEWORKS)
	INSTALL(
		DIRECTORY ${QT_ACTIVE_LIBRARIES} ${PHONON_LIBRARY}
		DESTINATION Frameworks
		REGEX "Headers|_debug" EXCLUDE
	)
	FOREACH(QT_FRAMEWORK ${QT_ACTIVE_LIBRARIES} ${PHONON_LIBRARY})
		GET_FILENAME_COMPONENT(QT_LIBRARY ${QT_FRAMEWORK} NAME_WE)
		RELOCATE_QT_LIBRARIES("Frameworks/${QT_LIBRARY}.framework/${QT_LIBRARY}")
		RENAME_OSX_LIBRARY("@executable_path/../Frameworks/${QT_LIBRARY}.framework/Versions/4/${QT_LIBRARY}" "Frameworks/${QT_LIBRARY}.framework/${QT_LIBRARY}")
	ENDFOREACH(QT_FRAMEWORK ${QT_ACTIVE_LIBRARIES})
ENDMACRO(INSTALL_QT_FRAMEWORKS)

MACRO(INSTALL_QT_PLUGINS)
	FOREACH(WANTED_QT_PLUGIN ${ARGN})
		GET_FILENAME_COMPONENT(WANTED_PLUGIN_DIR ${WANTED_QT_PLUGIN} PATH)
		INSTALL(FILES ${QT_PLUGINS_DIR}/${WANTED_QT_PLUGIN}.dylib DESTINATION MacOS/${WANTED_PLUGIN_DIR})
		RELOCATE_QT_LIBRARIES(MacOS/${WANTED_QT_PLUGIN}.dylib)
	ENDFOREACH(WANTED_QT_PLUGIN ${ARGN})
ENDMACRO(INSTALL_QT_PLUGINS)

MACRO(COMPRESS_PACKAGE VERSION)
	INSTALL(CODE
		"
		MESSAGE(STATUS Compressing...)
		FILE(REMOVE ${CMAKE_PROJECT_NAME}-${VERSION}.dmg)
		EXECUTE_PROCESS(COMMAND ln -sf /Applications OSXBundle/Applications)
		EXECUTE_PROCESS(
			COMMAND
				hdiutil create -srcfolder OSXBundle -volname ${CMAKE_PROJECT_NAME}-${VERSION} -format UDBZ ${CMAKE_PROJECT_NAME}-${VERSION}.dmg
		)
		"
	)
ENDMACRO(COMPRESS_PACKAGE)

# Build for tiger
SET(CMAKE_OSX_DEPLOYMENT_TARGET 10.4)
SET(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS} -mmacosx-version-min=${CMAKE_OSX_DEPLOYMENT_TARGET})
SET(CMAKE_OSX_ARCHITECTURES "i386;ppc")

SET(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/OSXBundle/${CMAKE_PROJECT_NAME}.app/Contents")
IF(EXISTS ${CMAKE_SOURCE_DIR}/Info.plist)
	INSTALL(FILES ${CMAKE_SOURCE_DIR}/Info.plist DESTINATION ${CMAKE_INSTALL_PREFIX}/)
ENDIF()
